#include "StringTable.hpp"

HINSTANCE StringTable::instanceHandle_ = nullptr;
TCHAR** StringTable::strings_ = nullptr;
TCHAR* StringTable::buffer_ = nullptr;

void StringTable::initialize(HINSTANCE instanceHandle)
{
	instanceHandle_ = instanceHandle;

	if (strings_ == nullptr)
		strings_ = new TCHAR*[RESOURCE_LENGTH];

	// S邽߂ɕKvȃTCY擾
	int stringBufferLength = 128;
	TCHAR* stringBuffer = new TCHAR[stringBufferLength];
	int bufferLength = 0;
	for (UINT i = RESOURCE_ID_START; i < RESOURCE_ID_START + RESOURCE_LENGTH; ++i)
	{
		for (;;)
		{
			int result = LoadString(instanceHandle_, i, stringBuffer, stringBufferLength);

			// ǂݍ߂ȂID̓XLbv
			if (result == 0)
			{
				strings_[i - RESOURCE_ID_START] = nullptr; // łnullptrႤ
				break;
			}

			// obt@ǂݍ݃TCY΂ꂪ̒
			if (result < stringBufferLength - 1)
			{
				strings_[i - RESOURCE_ID_START] = stringBuffer; // ʂt悤nullptrłȂKȒlƂ
				bufferLength += result + 1;
				break;
			}

			// obt@t܂œǂݍ܂Ăobt@Ȃ\̂ŊgăgC
			delete[] stringBuffer;
			stringBufferLength *= 2;
			stringBuffer = new TCHAR[stringBufferLength];
		}
	}
	delete[] stringBuffer;

	if (buffer_ == nullptr)
		buffer_ = new TCHAR[bufferLength];

	int written = 0;
	for (UINT i = RESOURCE_ID_START; i < RESOURCE_ID_START + RESOURCE_LENGTH; ++i)
	{
		// ǂ߂\[XIDΏۂƂ
		if (strings_[i - RESOURCE_ID_START] != nullptr)
		{
			int result = LoadString(instanceHandle_, i, &buffer_[written], bufferLength - written);
			if (result == 0)
				strings_[i - RESOURCE_ID_START] = nullptr;
			else
			{
				strings_[i - RESOURCE_ID_START] = &buffer_[written];
				written += result + 1;
			}
		}
	}
}

TCHAR* StringTable::get(int resourceId)
{
	if (strings_ == nullptr)
		return nullptr;

	if (resourceId < RESOURCE_ID_START || RESOURCE_ID_START + RESOURCE_LENGTH <= resourceId)
		return nullptr;

	if (strings_[resourceId - RESOURCE_ID_START] == nullptr)
		return nullptr;
	else
		return strings_[resourceId - RESOURCE_ID_START];
}

void StringTable::shutdown()
{
	if (buffer_ != nullptr)
	{
		delete[] buffer_;
		buffer_ = nullptr;
	}

	if (strings_ != nullptr)
	{
		delete[] strings_;
		strings_ = nullptr;
	}

	instanceHandle_ = nullptr;
}

